// GBA test prog 2
// "real programmers comment their stuff"
//
#include <stdlib.h>

// Hardware registers
// need to use volatile for the registers we read, otherwise
// the compiler tries to be clever.
#define DISPCNT		((unsigned short *)0x04000000)
#define DISPSTAT	((volatile unsigned short *)0x04000004)
#define PALETTE		((unsigned char *)0x05000000)
#define SCREEN		((unsigned char *)0x06000000)
#define VCOUNT		((volatile unsigned char *)0x04000006)
#define MOSAIC		((unsigned short *)0x0400004C)
#define BG2CNT		((unsigned short *)0x0400000C)

// Sync to vertical blank
void vsync(void) {
	unsigned char line;

loop1:
	line = *VCOUNT;
	if(line != 160) goto loop1;		// wait till last display line
	// "they took the best parts from BASIC and made C.."
}

// screen clear (writes words)
// fairly fast - check out the asm generated
void clear(void) {
	// clear screen
	unsigned long *p;
	int i;
	
	p = (unsigned long *)SCREEN;
	for(i=9600; i;i--) *p++ = 0;
}

// where does _start come from ???
int main(void) {
	int i, j;
	unsigned char *p;
	unsigned char c;
	int x[100], y[100], z[100];		// stars coords
	int sx, sy;

	// set DISPCNT for BG mode = 4, BG2 screen disp on
	*DISPCNT = 0x0404;

	// write some palette data
	p = PALETTE;
	for(i=0; i<512; i++) {
		*p++ = i % 128;
	}

	clear();	// clear screen

	// write some gfx data
	p = SCREEN;
	for(i=0; i<140; i++) {
		//*(p + i + i*240) = 255;		// diagonal line
	}
	for(i=0; i<140; i++) {
		//*(p + (239-i) + i*240) = 255;		// diagonal line
	}

	// set up stars
	for(i=0; i<100; i++) {
		x[i] = rand() % 2000 - 1000;
		y[i] = rand() % 2000 - 1000;
		z[i] = rand() % 400;
	}

	// this doesn't work (!)
    *MOSAIC = 0x0033;
    *BG2CNT = 0x0040;		// BG2 Mosaic bit
    
	// draw stars
	p = SCREEN + 19200 + 120;			// p points to middle of screen
	for(j=0; j<50000; j++) {
		vsync();
		clear();
		for(i=0; i<100; i++) {
			sx = x[i] / z[i];			// perspective projection
			sy = y[i] / z[i];
			//sx = x[i];
			//sy = y[i];
			*(p + sx + sy * 240) = 255;
			z[i]--;
			if(z[i] < 10) z[i] += 400;
		}
	}

    // loop forever
	while(1) ;

 return 0;
}


